% This script recompiles gpu_kernels.cu and adds path variables to
% Matlab's search path. Run it before using the toolbox or add it
% to your startup.m

% current dir:
curdir = fileparts(mfilename('fullpath'));
%(something like: 'C:\M-Project(GPU)\J');

% add everything that is needed to matlab path:
addpath(fullfile(curdir, 'lib'));
addpath(fullfile(curdir, 'scripts'));
addpath(fullfile(curdir, 'functions'));
addpath(fullfile(curdir, '3rd_party', 'photonattenuation'));
addpath(fullfile(curdir, '3rd_party', 'spektr_v2_1'));
addpath(fullfile(curdir, '3rd_party', 'edf_readers'));
addpath(fullfile(curdir, 'gpu_kernels'));

% recompile CUDA kernels for GPU_mat:
GPU_mat.recompile_kernels(curdir);
