function int = integral(x, y)
    %Calculate the surface ander the curve. 
    % 
    % INTEGRAL(X, Y)  - uses trapezoidal rule to calculate integral 
    % of the function Y on non-uniform grid defined by X.
    
    if length(y) > 1
        int = sum((x(2:end) - x(1:end - 1)) .* (y(2:end) + y(1:end - 1)) ./ 2) / (max(x) - min(x));
    else
        int = y;
    end
end