function r = radial_average(x)
    %Calculate radial average of 2D image.
    %
    % RADIAL_AVERAGE(X) Calculate radial average of X with the center
    % of coordinates in the center of the image.
    %
    % See Also: radial_average_2d, rrr

    % Radial system:
    rs = rrr(x, size(x) / 2 + 1);

    % Calculating average x:
    r = zeros(1, size(x, 1) / 2);

    % Loop in the radial direction:
    for ii = 0:(size(x, 1) / 2 - 1)
        
        r(ii+1) = mean(x((rs >= ii) & (rs < (ii+1))));
    end
end
