function sz = size_gen(varargin)
%SIZE_GEN(VARARGIN) Generates 2-elements size-vector defined by
% VARARGIN. VARARGIN can be a reference image, a size-vector, 
% two numbers apart or a singe number.

    if size(varargin) == 1
        % if varargin is a single variable:
        x = varargin{1};

        if numel(x) > 3
            % it's an image:
            sz = size(x);        

        elseif numel(x) > 1
            % it's n-elements vector:
            sz = x;        

        else
            % it's 1-element vector:
            sz = [x, x];
        end
    else
        % if varargin is two variables:
        sz = [varargin{1}, varargin{2}];
    end
end