function image = xxx(par, center)
    %Generate a gradient along the second dimension. 
    %
    % IMAGE = XXX(PAR, CENTER) - Generate IMAGE that contains 
    % values increasing along the second dimension of the image.
    % CENTER defines the origin of the gradient. PAR defines the
    % size of the image (can be a reference image or the size).
    %
    % See also: rrr, yyy, zzz
    
    % image init:
    sz = size_gen(par);
    
    if nargin < 2
        center = floor(sz / 2) + 1;
    end
    
    % Generate gradient:
    image = ones(sz(1), 1) * ((1:sz(2)) - center(2));
    
    %3D case:
    if numel(sz) == 3
        image = repmat(image, [1, 1, sz(3)]);
    end

       
end