function image = yyy(par, center)
    %Generate a gradient along the first dimension. 
    %
    % IMAGE = YYY(PAR, CENTER) - Generate IMAGE that contains 
    % values increasing along the first dimension of the image.
    % CENTER defines the origin of the gradient. PAR defines the
    % size of the image (can be a reference image or the size).
    %
    % See also: rrr, xxx, zzz
    
    % image init:
    sz = size_gen(par);
    
    if nargin < 2
        center = floor(sz / 2) + 1;
    end
    
    % Generate the gradient:
    image = ((1:sz(1))' - center(1)) * ones(1, sz(2));
    
    %3D case:
    if numel(sz) == 3
        image = repmat(image, [1, 1, sz(3)]);
    end
        
end