function zeros = zero_crossings(image, dim)

    if nargin < 2
        dim = -1;
    end
    
    if dim == 1 
        zeros = sign(image(2:end, :)) .* sign(image(1:end-1, :)) < 0;
        zeros(end + 1, 1) = 0;
    elseif dim == 2
        zeros = sign(image(: ,2:end)) .* sign(image(:, 1:end-1)) < 0;
        zeros(1, end + 1) = 0;
    else
        zeros = imdilate(image > 0, strel('disk', 1, 0)) & (image <= 0);
    end

end