function image = zzz(par, center)
    %Generate a gradient along the 3rd dimension. 
    %
    % IMAGE = ZZZ(PAR, CENTER) - Generate IMAGE that contains 
    % values increasing along the first dimension of the image.
    % CENTER defines the origin of the gradient. PAR defines the
    % size of the image (can be a reference image or the size).
    %
    % See also: rrr, xxx, yyy
    
    % image init:
    sz = size_gen(par);
    
    if nargin < 2
        center = floor(sz / 2) + 1;
    end
    
    % Generate the gradient:
    if numel(sz) < 3
        error('You dumb! we`ve gone 3D now!!!');
    else
        %3D case:
        image = ones(sz(1), 1) * ((1:sz(3)) - center(3));
        image = reshape(image, [sz(1), 1, sz(3)]);
        
        image = repmat(image, [1 sz(2) 1]);
    end
        
end