%clear all;
%close all;
load('~/calculations/xenopus_result/sino', 'sino');

%% cudown the size:
 
bin = 2;
sino_ = (sino(1:2:end-1, :,:) + sino(2:2:end,:,:))/2;
sino_ = (sino_(:, 1:2:end-1, :) + sino_(:,2:2:end,:))/2;
sino_ = (sino_(:,:,1:2:end-1) + sino_(:,:,2:2:end))/2;

% flip dimensions > ASTRA uses sinogram(x, theta, z) instead of (x, z, theta);
sino_ = permute(sino_, [1 3 2]);
 
proj_n = size(sino_, 2);
sz = size(sino_);

%show(volume(:,:,end/2), []);
disp('sinogram is binned x2');

mea1 = mean(mean(sino_(1:10, :, 1:10), 1), 3);
mea2 = mean(mean(sino_(1:10, :, end-10:end), 1), 3);
mea3 = mean(mean(sino_(end-10:end, :, end-10:end), 1), 3);
mea4 = mean(mean(sino_(end-10:end, :, 1:10), 1), 3);

mea = (mea1 + mea2+ mea3+ mea4)/4;

sino_ = log(sino_ ./ repmat(mea, [size(sino_, 1), 1, size(sino_, 3)]));
disp('log is applied to the sinogram');

%% deconvolve:
r1 = inf;           % meters
r2 = 0.945;           % meters
pixelsize = 0.745e-6*bin;
energy = 20e3;
sigma = 0.745e-6;
theta = (0:(proj_n-1))/(proj_n-1)*2*pi;

w = single(sin(...
PCI_rec.frequency_space([sz(1),sz(3)], pixelsize, energy, r1, r2)));

%z = imdilate(zero_crossings(w), strel('disk', 1, 0));
%z(1:5, 1:5, 1:5) = 0;
 
% total CTF:
w = single(w .* detection.gaussian_ctf(w, pixelsize, sigma));

% because of ASTRA the sinogram dimensions are {x, theta, z}:
w = repmat(w, [1 1 proj_n]);
w = permute(w, [1 3 2]);

% ASTRA wrapper for RADON transform:
aw = ASTRA_wrapper;
aw.memory_limit = 2^30;

%clear z;
x0 = aw.IRADON_3D(sino_, theta);
 
%% begin!
 
f = TV_min3d(); 
f.display_it = 0;
 
l = 1;
 
f.calc = CPU_mat3df;

% Knowns/unknowns:
f.X = x0;%zeros(sz(1),sz(1),sz(3), 'single');
f.Y = fft(fft(sino_), [], 3);

% clear memory:
clear sino;
clear sino_;
clear x0;
 
% Define the linear model A(x):
f.A = @(x) w .* fft(fft(aw.RADON_3D(x, theta)), [], 3);
f.A_trans = @(x) aw.IRADON_3D(real(ifft(ifft(w .* x), [], 3)), theta);
 
%save('all');
 
f.L = l;
 
% Initialization parameters ofmax the algorithm:
f.n_iter = 1000;
f.lambda = 0.0001*0;
f.bounds = [-inf, 0];
f.X_true = [];
f.save_it = 10;
f.save_file = '~/calculations/xenopus_result/intermid_';
f.history_it = 0;
 
%clear w;
%clear volume;
%clear volume_rec;

disp('Iterations started!'); 

% Calculate!
x = f.run();
disp('FISTA is done');
%%
%show(x, []);

%figure;
%plot(history.L2);
 
%% save data:
%save('volume_fista', 'x', '-v7.3');
%save('history_fista', 'history');
save('~/calculations/xenopus_result/recon_full', 'x', '-v7.3');
exit;
%load('~/calculations/xenopus_result/recon_full_hist', 'history');
