%% mouse:

path = '~/calculations/xenopus_20KeV/';
scan_files = 'int_*.edf';

% Make the filelist:
files = dir(fullfile(path, scan_files));
proj_n = 1600;

theta = (0:(proj_n-1))/(proj_n-1)*360;

%% read the first file:

im1 = pmedfread(fullfile(path, files(1).name));

im_sz = size(im1);

%figure(1);
%imshow(im1, []); title('first projection');

%% construct sinogram:

sino = zeros([size(im1) proj_n], 'single');

disp('loading projections...')
for ii = 1:proj_n
    sino(:, :, ii) = pmedfread(fullfile(path, files(ii).name));
    
    disp(ii/proj_n);
end

%sino = single(squeeze(data(:,im_sz(2)/2+1:im_sz(2)/2+depth, :)));

%%
%show(sino, 'lin',2); title('sinogram');
shi = 20;
disp('moving axis');

for ii = 1:size(sino, 2)
    sino(:,ii,:) = imshift(squeeze(sino(:,ii,:)), [shi 0]);
    disp(ii);
end

sino = sino(shi+1:1:end-shi, :,:);
%% 3d FBP:
% !!!!!!!!!!!!!!!!!
width = size(sino, 1);
depth = size(sino, 2);

me = mean(mean(mean(sino(1:11,:,:))))/2 + mean(mean(mean(sino(end-10:end,:,:))))/2;

%fbp = iradon(squeeze(sino)/me-1, theta,'linear', 'Ram-Lak', 1, size(sino, 1));
%show(-fbp, 'lin', 10, '`Raw` FBP');

volume = zeros([width width depth], 'single');

disp('calculating FBP...');
for ii = 1:depth
    volume(:,:,ii) = single(iradon(log(squeeze(sino(:,ii,:))./me), theta,'linear', 'Ram-Lak', 1, width));
    disp(ii/depth);
end

save('xenopus_vol', 'volume', '-v7.3');
