%clear all;
%close all;
load('xenopus_vol');

%% cudown the size:

bin = 2;
volume = (volume(1:2:end-1, :,:) + volume(2:2:end,:,:))/2;
volume = (volume(:, 1:2:end-1, :) + volume(:,2:2:end,:))/2;
volume = (volume(:,:,1:2:end-1) + volume(:,:,2:2:end))/2;

%show(volume(:,:,end/2), []);
disp('volume binned x2');
%% deconvolve:
r1 = inf;           % meters
r2 = 0.945;           % meters
pixelsize = 0.745e-6*bin;
energy = 20e3;
sigma = 0.745e-6;

w = single(PCI_rec.frequency_space(volume, pixelsize, energy, r1, r2));
w = sin(w);

tic;
volume_rec = fftn(volume);
disp('fftn is done in ...');
disp(toc);

z = imdilate(zero_crossings(w), strel('disk', 1, 0));
z(1:5, 1:5, 1:5) = 0;

volume_rec = volume_rec .* w ./ (w.^2 + 0.000001);
%volume_rec = volume_rec ./ w;
%volume_rec(1,1,1) = 0;
volume_rec(z) = 0;
volume_rec = real(ifftn(volume_rec));

save('volume_deconvol','volume_rec', '-v7.3');
%show(volume_rec(:,:,end-32), [-0.008 0.03]);

%% clear stuff
w(z) = 0;
w = single(w .* detection.gaussian_ctf(w, pixelsize, sigma));

clear z;

%% begin!

f = TV_min3d(); 
f.display_it = 0;

l = 1;

gpuCalc = CPU_mat3d;
f.calc = gpuCalc;

% Knowns/unknowns:
f.X = zeros(size(volume), 'single');
f.Y = w .* fftn(volume);

ww = (w.^2);

% Define the linear model A(x):
f.A = @(x) ww .* fftn(x);
f.A_trans = @(x) real(ifftn(x));

%save('all');

f.L = l;
 
% Initialization parameters ofmax the algorithm:
f.n_iter = 1000;
f.lambda = 0.0001;
f.bounds = [-inf, inf];
f.X_true = [];
f.save_it = 50;
f.save_file = 'fista_iterm_nolims_larger_la_';

clear w;
clear volume;
clear volume_rec;
 
% Calculate!
tic
[x, history] = f.run();
disp('FISTA is done in ...');
disp(toc);

save('volume_fista', 'x', '-v7.3');
save('history_fista', 'history');
